<?php
//  ---------------------------------------------------------------------------------
//    _____   _             _                   _   _____
//   |  __ \ | |           | |    /\           (_) |  __ \
//   | |__) || |__    __ _ | |   /  \    _ __   _  | |__) |_ __  ___
//   |  ___/ | '_ \  / _` || |  / /\ \  | '_ \ | | |  ___/| '__|/ _ \
//   | |     | | | || (_| || | / ____ \ | |_) || | | |    | |  | (_) |
//   |_|     |_| |_| \__,_||_|/_/    \_\| .__/ |_| |_|    |_|   \___/
//                                      | |
//                                      |_|
//   PhalApi Pro 专业版
//   广州果创网络科技有限公司
//
//  ---------------------------------------------------------------------------------
//
//   一、协议的许可和权利
//    1. 您可以在完全遵守本协议的基础上，将本软件应用于商业用途；
//    2. 您可以在协议规定的约束和限制范围内修改本产品源代码或界面风格以适应您的要求；
//    3. 您拥有使用本产品中的全部内容资料、商品信息及其他信息的所有权，并独立承担与其内容相关的
//       法律义务；
//    4. 获得商业授权之后，您可以将本软件应用于商业用途，自授权时刻起，在技术支持期限内拥有通过
//       指定的方式获得指定范围内的技术支持服务；
//
//   二、协议的约束和限制
//    1. 未获商业授权之前，禁止将本软件用于商业用途（包括但不限于企业法人经营的产品、经营性产品
//       以及以盈利为目的或实现盈利产品）；
//    2. 未获商业授权之前，禁止在本产品的整体或在任何部分基础上发展任何派生版本、修改版本或第三
//       方版本用于重新开发；
//    3. 如果您未能遵守本协议的条款，您的授权将被终止，所被许可的权利将被收回并承担相应法律责任；
//
//   三、有限担保和免责声明
//    1. 本软件及所附带的文件是作为不提供任何明确的或隐含的赔偿或担保的形式提供的；
//    2. 用户出于自愿而使用本软件，您必须了解使用本软件的风险，在尚未获得商业授权之前，我们不承
//       诺提供任何形式的技术支持、使用担保，也不承担任何因使用本软件而产生问题的相关责任；
//    3. 广州果创网络科技有限公司不对使用本产品构建的商城中的内容信息承担责任，但在不侵犯用户隐
//       私信息的前提下，保留以任何方式获取用户信息及商品信息的权利；
//
//   有关本产品最终用户授权协议、商业授权与技术服务的详细内容，均由广州果创网络科技有限公司独家
//   提供。广州果创网络科技有限公司拥有在不事先通知的情况下，修改授权协议的权力，修改后的协议对
//   改变之日起的新授权用户生效。电子文本形式的授权协议如同双方书面签署的协议一样，具有完全的和
//   等同的法律效力。您一旦开始修改、安装或使用本产品，即被视为完全理解并接受本协议的各项条款，
//   在享有上述条款授予的权力的同时，受到相关的约束和限制。协议许可范围以外的行为，将直接违反本
//   授权协议并构成侵权，我们有权随时终止授权，责令停止损害，并保留追究相关责任的权力。
//
//  ---------------------------------------------------------------------------------

namespace Mall\Domain;

use Mall\Model\Mall\Flow as FlowModel;
use Mall\Model\Mall\Product as ProductModel;
use PhalApi\Exception\BadRequestException;
use Base\Domain\User;
use Base\Domain\Apps;

class Flow {
    
    /** ------------------------ 开放平台 ------------------------ **/

    public function getMyFlowList($page, $perpage){
        $uid = \PhalApi\DI()->context->getUid();

        $model = new FlowModel();
        $select = '*';
        $data = $model->getListEx('member_id = :member_id', array(':member_id' => $uid), $select, 'id DESC', $page, $perpage);
        $map = $this->getFlowStatusList();
        foreach ($data['items'] as &$itRef) {
            $itRef['flow_status_name'] = isset($map[$itRef['flow_status']]) ? $map[$itRef['flow_status']] : $itRef['flow_status'];
            $itRef['used_percent'] = $itRef['total_amount'] > 0 ? round($itRef['used_amount'] * 100 / $itRef['total_amount'], 2) : 100;
            $itRef['expire_time_str'] = date('Y-m-d H:i:s', $itRef['expire_time']);
        }
        return $data;
    }


    //获取我的套餐总数
    public function getMyFlowCount(){
        $uid = \PhalApi\DI()->context->getUid();
        $model = new FlowModel();
        return $model->count(['member_id'=>$uid]);

    }

    // 发放接口流量
    public function sendOrderFlow($order) {
        // 判断是单个接口，还是组合套餐
        if ($order['product_type'] == ProductModel::PRODUCT_TYPE_API_BUY) {
            return $this->sendOrderFlowOneService($order);
        }
        
        // 组合套餐发放
        $idArr = array();
        $pModel = new ProductModel();
        $productIdArr = explode(',', $order['product_key']);
        foreach ($productIdArr as $pId) {
            $pInfo = $pModel->get($pId);
            if (!$pInfo) {
                continue;
            }

            // 加工订单信息，单独变化
            $oneOrder = $order;
            $oneOrder['order_name'] .= '-' . $pInfo['product_name'];
            $oneOrder['product_key'] = $pInfo['product_key']; // 修改为单个接口的
            $oneOrder['product_amount'] = $pInfo['amount']; // 以单个套餐的数量为准

            $idArr[] = $this->sendOrderFlowOneService($oneOrder);
        }

        return $idArr;
    }
    
    // 针对单个接口的流量订单发放
    public function sendOrderFlowOneService($order) {
        $newFlow = array(
            'member_id' => intval($order['member_id']),
            'username' => $order['username'],
            
            'order_id' => $order['order_id'],
            'product_name' => $order['order_name'],
            
            'product_key' => $order['product_key'],
            'product_key_lower' => strtolower($order['product_key']),
            
            'flow_status' => FlowModel::FLOW_STATUS_NEW,
            'product_type' => ProductModel::PRODUCT_TYPE_API_BUY,
            'used_amount' => 0,
            'total_amount' => $order['num'] * $order['product_amount'],
            'expire_time' => $order['product_expire_time'] + $_SERVER['REQUEST_TIME'],
            'add_time' => date('Y-m-d H:i:s'),
        );
        
        $model = new FlowModel();
        return $model->insert($newFlow);
    }

    // 回收接口流量
    public function takebackOrderFlow($order_id) {
        $model = new FlowModel();
        return $model->updateAll(array('order_id' => $order_id), array('flow_status' => FlowModel::FLOW_STATUS_CANCEL));
    }

    /** ------------------------ 管理后台 ------------------------ **/
    
    public function addNewFlow($flow) {
        $userDomain = new User();
        $user = $userDomain->profile($flow['username']);
        if (!$user) {
            throw new BadRequestException(\PhalApi\T('user does not exist or is blocked'));
        }

        $newData = $flow;
        $newData['member_id'] = $user['id'];
        $newData['product_key_lower'] = strtolower($newData['product_key']);
        $newData['add_time'] = date('Y-m-d H:i:s');
        $newData['flow_status'] = FlowModel::FLOW_STATUS_NEW;
        $newData['product_type'] = ProductModel::PRODUCT_TYPE_API_BUY;
        $newData['used_amount'] = 0;

        $model = new FlowModel();
        $id = $model->insert($newData);

        return intval($id); 
    }

    public function updateFlow($id, $flow) {
        $model = new FlowModel();
        $oldFlow = $model->get($id);
        if (!$model) {
            return false;
        }

        $isUpdate = $model->update($id, $flow);
        return $isUpdate ? true : false;
    }

    public function getFlow($id) {
        $model = new FlowModel();
        $flow = $model->get($id);
        return $flow ? $flow : null;
    }

    public function deleteFlow($id) {
        $model = new FlowModel();
        return $model->delete($id) ? true : false;
    }

    public function getFlowList($page, $perpage){
        $model = new FlowModel();
        $select = '*';
        $data = $model->getListEx(NULL, array(), $select, 'id DESC', $page, $perpage);
        $map = $this->getFlowStatusList();
        foreach ($data['items'] as &$itRef) {
            $itRef['flow_status_name'] = isset($map[$itRef['flow_status']]) ? $map[$itRef['flow_status']] : $itRef['flow_status'];
            $itRef['used_percent'] = $itRef['total_amount'] > 0 ? round($itRef['used_amount'] * 100 / $itRef['total_amount'], 2) : 100;
            $itRef['expire_time_str'] = date('Y-m-d H:i:s', $itRef['expire_time']);
        }
        return $data;
    }

    public function getFlowStatusList($isMap = true) {
        $map = FlowModel::getFlowStatusList();

        if (!$isMap) {
            $list = array();
            foreach ($map as $key => $val) {
                $list[] = array('name' => $val, 'key' => $key);
            }
            $map = $list;
        }

        return $map;
    }
    
    /** ------------------------ 使用(针对API接口) ------------------------ **/
    
    /**
     * 核心模块：对开发者使用接口进行流量计费
     *
     * - 扣费优先级：正常套餐 > 免费套餐；先扣最早付费的。
     * - 如果从未有过免费套餐时，则自动补充创建
     *
     * @return int -1/0/1+，负数表示扣费失败，0表示无须扣费，1表示扣费成功
     */
    public function cutdown($service, $appKey) {
        // 检测接口是否需要付费
        $products = Product::getFlowProducts($service);
        if (empty($products)) {
            return 0;
        }

        // 取开发者的有效套餐
        $model = new FlowModel();
        $flows = $model->loadDevUserFlows($service, $appKey);

        // 短路扣费
        foreach ($flows as $it) {
            $model->cutdownFlow($it);
            return $it['id'];
        }
        
        // 尝试免费的
        $itemFree = $model->loadDevUserFreeFlow($service, $appKey);
        if (!empty($itemFree)) {
            if (in_array($itemFree['flow_status'], array(FlowModel::FLOW_STATUS_NEW, FlowModel::FLOW_STATUS_USING))) {
                $model->cutdownFlow($itemFree);
                return $itemFree['id'];
            }
        } else {
            // 自动创建免费套餐
            foreach ($products as $pItem) {
                if ($pItem['product_type'] != ProductModel::PRODUCT_TYPE_API_FREE) {
                    continue;
                }
                
                $newData = array();
                $newData['product_name'] = $pItem['product_name'];
                $newData['product_key'] = $pItem['product_key'];
                $newData['product_key_lower'] = strtolower($newData['product_key']);
                $newData['total_amount'] = $pItem['amount'];
                $newData['expire_time'] = $pItem['expire_time'] + $_SERVER['REQUEST_TIME'];

                $appDomain = new Apps();
                $uidCfg = $appDomain->getApp($appKey, 'uid');
                $devUid = $uidCfg['uid'];
                
                $userDomain = new User();
                $username = $userDomain->getUsername($devUid);

                $newData['member_id'] = intval($devUid);
                $newData['username'] = strval($username);

                $newData['used_amount'] = 1;
                $newData['add_time'] = date('Y-m-d H:i:s');
                $newData['flow_status'] = FlowModel::FLOW_STATUS_USING;
                $newData['product_type'] = ProductModel::PRODUCT_TYPE_API_FREE;

                $id = $model->insert($newData);
                return intval($id);
            }
        }
        
        // 扣费失败
        return -1;
    }
}
